#ifndef _LOGSTREAM_H_
#define _LOGSTREAM_H_

// This file defines some hacks for using streams & LogHandlers for 
// (conditional) output.
//
// Once Coral has been revamped to use streams, these routines should
// be incorporated too.  This code will be much smaller & faster once
// most of it has been moved into the execution environment.  (Basically,
// the creation of the output stream & LogHandler will be removed & placed
// in the routines for maintaining exEnv.


#include <stdiostream.h>
#include <iostream.h>
#include "ExecutionEnv.h"
#include "LogHandler.h"
#include "Debug.h"


//---------------------------------------------------------------------------

#define ERROR_MSG(M) { \
	    LogHandler lh(Cor_exEnv->err_strm,1); \
            LOG_MSG(lh,M) \
	  }

//---------------------------------------------------------------------------

#ifdef DO_TRACE

#define TRACE(M) { \
	    LogHandler lh(Cor_exEnv->trace_strm,1); \
            LOG_MSG(lh,M) \
	  }
#define TRACE_INSERTION(M)  if(DISPLAY_INSERTIONS) TRACE(M);

#else // !DO_TRACE

#define TRACE(M)
#define TRACE_INSERTION(M)

#endif // DO_TRACE

//---------------------------------------------------------------------------

#endif // _LOGSTREAM_H_
