
//**************************************************************************
//    PvmConnectArray.h
//
//    The PvmConnectArray Class - A class derived from ConnectArray to
//    handle connections by PVM.
//
//**************************************************************************

#ifndef _PVMCONNECTARRAY_H_
#define _PVMCONNECTARRAY_H_

#include "ConnectArray.h"
#include "PvmStream.h"

//**************************************************************************

class Cor_PvmConnectArray : public Cor_ConnectArray {

private:

    int server_tid;             // the tid of the server
    int explain_tid;            // the tid of the explain server

    // the tids of all clients connecting to this server
    int client_tids[MAX_CONNECTIONS];
    
public:

    // Constructor
    Cor_PvmConnectArray();

    // Destructor
    ~Cor_PvmConnectArray();

    // Delete a connection
    void DeleteConnection(int conn_indx);

    // Establish a connection for Explain
    int ExplainConnection();

    // Get the next connection with data and set it up to run
    int NextConn();
};

//**************************************************************************
    
#endif // _PVMCONNECTARRAY_H_
