// *************************************************************************
//  Reference.h
// *************************************************************************

// *************************************************************************

class Cor_RefdData {

    friend class Cor_Reference;
  public:
    Cor_RefdData()            { ref_count = 0; };
    virtual ~Cor_RefdData()        { };
    void IncRef();
    void DecRef();
  protected:
    short int ref_count;
};


void inline Cor_RefdData::IncRef()
{
    ref_count++;
}

void inline Cor_RefdData::DecRef()
{
#   ifdef DEBUG
    if (ref_count <= 0) {
    *(Cor_exEnv->err_strm) << "fatal error: reference count < 0\n";
    // dump core
    }
#   endif

    if (--ref_count == 0) delete this;
}

// *************************************************************************

class Cor_Reference {

  public:
    Cor_Reference()            { ptr = NULL; }
    Cor_Reference(Cor_Reference& r)   { if (ptr = r.ptr) ptr->IncRef(); }
    Cor_Reference(Cor_RefdData *d)    { if (ptr = d) ptr->IncRef(); }
   ~Cor_Reference()            { if (ptr) ptr->DecRef(); }

    void operator=(Cor_Reference& src);
    void operator=(Cor_RefdData *d);
    Cor_RefdData operator*()        { return(*ptr); }
    Cor_RefdData *operator->()        { return(ptr); }
    operator Cor_RefdData*()        { return(ptr); }

  protected:
    Cor_RefdData *ptr;
};

inline void Cor_Reference::operator=(Cor_Reference& src)
{
    if (ptr) ptr->DecRef();
    if (ptr = src.ptr) ptr->IncRef();
}

inline void Cor_Reference::operator=(Cor_RefdData *d)
{
    if (ptr) ptr->DecRef();
    if (ptr = d) ptr->IncRef();
}

/*****************************************************************************/

