// *************************************************************************
//	Unify.h
// *************************************************************************

#ifndef _Unify_H_
#define _Unify_H_

#include "BindEnv.h"
#include "Term.h"
#include "ArgList.h"
#include "Debug.h"

// *************************************************************************

class Cor_Tuple;
class Cor_TupleIterator;

// *************************************************************************

#define COR_U_FAIL 0
#define COR_U_SUCCEED 1

// *************************************************************************

/** unify_binding and subsumes_binding used Term &term earlier **/

int Cor_unify_binding (Cor_BindEnv *env, Variable var, Cor_Term term);
int Cor_unify_args (Cor_Term left, Cor_Term right);

  // Optimizations, to avoid full unify against a fact in a db relation
  // (and thus, known to be ground).
int Cor_Assign_args (Cor_Term& vartrm, Cor_Term& dbtrm);
int Cor_Assign_args (Cor_CArg *vararg, Cor_BindEnv *env, Cor_CArg *dbarg);

int Cor_EqlChk_args (Cor_Term& vartrm, Cor_Term& dbtrm);
int Cor_EqlChk_args (Cor_Term& vartrm, Cor_CArg *dbarg);
int Cor_EqlChk_args (Cor_CArg *var_arg, Cor_BindEnv *var_env, Cor_CArg *dbarg);

int Cor_Match_Arg( Cor_CArg *var_arg, Cor_BindEnv *var_env, Cor_CArg *db_arg);
int Cor_Match_args  (Cor_Term& vartrm, Cor_Term& dbtrm);


int Cor_unify_arg (Cor_CArg& left, Cor_CArg& right,
        Cor_BindEnv *left_bindings, Cor_BindEnv *right_bindings);
int Cor_unify_arg_lists (Cor_ArgList& left, Cor_ArgList& right,
        Cor_BindEnv *left_bindings, Cor_BindEnv *right_bindings);

int Cor_unify_literal(Cor_TupleIterator& iterator, Cor_Tuple *tuple,
         int display);

int Cor_subsumes_tuple(Cor_Tuple *tuple, Cor_Tuple *newtuple, int display);
int Cor_subsumes_binding(Cor_BindEnv *bindenv, Variable var,
        Cor_Term term, int can_bind);

int Cor_subsumes_arg_lists(Cor_ArgList& left, Cor_ArgList& right,
    Cor_BindEnv *left_bindings, Cor_BindEnv *right_bindings);

int Cor_subsumes_value(CArgKind aggkind, Cor_CArg val1, Cor_CArg val2,
        Cor_BindEnv *env1, Cor_BindEnv *env2);

int Cor_equal_tuples(Cor_Tuple *tuple1, Cor_Tuple *tuple2, int display);

// *************************************************************************

#endif _Unify_H_

