####################
# mkDialog string 
#
# Create a dialog box with a message and an OK button (no choice,
#    rather a Apple mcintosh type style)
#
# Arguments:
#    string -    A string to display
#

proc mkDialog {txt {justify center}} {

    catch {destroy .messwin}
    toplevel .messwin -class Dialog
    wm title .messwin "Info"
    wm iconname .messwin "Info"

    # Create two frames in the main window. The top frame will hold the
    # message and the bottom one will hold the buttons.  Arrange them
    # one above the other, with any extra vertical space split between
    # them.

    frame .messwin.top -relief raised -border 1
    frame .messwin.bot -relief raised -border 1
    pack .messwin.top .messwin.bot -side top -fill both -expand yes
    
    # Create the message widget and arrange for it to be centered in the
    # top frame.
    
    message .messwin.top.msg -justify $justify -width 400 \
            -font *-Courier-Bold-R-Normal-*-120-* -text $txt
        
    pack .messwin.top.msg -side top -expand yes -padx 3 -pady 3

    # Create as many buttons as needed and arrange them from left to right
    # in the bottom frame.  Embed the left button in an additional sunken
    # frame to indicate that it is the default button, and arrange for that
    # button to be invoked as the default action for clicks and returns in
    # the dialog.

    frame .messwin.bot.0 -relief sunken -border 1
    pack .messwin.bot.0 -side left -expand yes -padx 10 -pady 10
    button .messwin.bot.0.button -text "Okay" -command "destroy .messwin"
    pack .messwin.bot.0.button -expand yes -padx 6 -pady 6
    bind .messwin <Return> "destroy .messwin"

    bind .messwin <Any-Enter> [list focus .messwin]
    focus .messwin

# This should be placed on top of the window that caused the error!
#    (Put on top of . for now...)

    scan [wm geometry .] "%dx%d+%d+%d" height width xpos ypos

    incr xpos 200
    incr ypos 200
    set geo "+$xpos+$ypos"
    wm geometry .messwin $geo
}

####################
