

module append.
export append(bbf).
@pipelining +.

/*  This is the fastest of the CORAL append programs.  Pipelining
is essentially Prolog-style top-down, left-to-right backtracking
evaluation.  The (significant) difference in speed between this program executed
on CORAL and on, say, Quintus Prolog is a measure of the differences
in low-level compiler optimizations, rather than a difference in 
basic evaluation algorithms.  */

append([], X, X).
append([X|Y], Z, [X|W]) :- append(Y, Z, W).

end_module.

