#include "RdbCursor.h"
#include "RdbQuery.h"

// note:: move this later... demo time now...

static ostream& operator<<(ostream& os, const RdbItemList& items)
{
    int s = items.Size();
    os << "[";
    for( int i = 0 ; i < s ; i++ ) {
	if( i > 0 )
	  os << ", ";
	os << items[i];
    }
    os << "]";
    return os;
}



RdbCursor::RdbCursor( RdbQuery& newQuery, RdbItemList& newBindings )
: RdbError(),
  query( newQuery ),
  bindings( newBindings )
{
    query.Database().RegisterCursor( *this );
    if( query.Open( *this ) )
      ready = FALSE;
    else
      ready = TRUE;
}


RdbCursor::~RdbCursor()
{
    query.Close( *this );
    query.Database().DeregisterCursor( *this );
}


RdbError::ErrorCode RdbCursor::GetNext(RdbItemList& result)
{
    ErrorCode rc;
    if( !ready ) {
	cout << "Rdb Warning:: restarting cursor at top!\n";
	if( rc = query.Open( *this ) )
	  return rc;
	ready = TRUE;
    }
    rc = query.GetNext( *this, result );
    RDBLOG(query.Database().DBLog(), "return: "<<result<<"\n");
    return rc;
}
