# line 1 "RdbIngresInsert.scc"	

#include "RdbIngresInsert.h"
#include "Log.h"

#ifndef _SQLCA_H_
# include "/ingres/r6/ingres/files/eqsqlca.h"
    extern IISQLCA sqlca;   /* SQL Communications Area */
#endif
#ifndef _SQLDA_H_
# include "/ingres/r6/ingres/files/eqsqlda.h"
#endif
#include "IngresProtos.h"


unsigned RdbIngresInsert::insertNum = 0;


RdbIngresInsert::RdbIngresInsert(RdbRelation& newRel)
: RdbInsert(newRel)
{ 
    id = String("ins") + insertNum++; 
    CreateStmt();
    Describe();
}



RdbError::ErrorCode RdbIngresInsert::VInsert(const RdbItemList& newTuple)
{
  char *stmt_id = id;

    Bind( newTuple );
    IISQLDA* sqlda = tupleDA;

    LOG("inserting on stmt "<<stmt_id<<'\n');
# line 37 "RdbIngresInsert.scc"	/* execute */
  {
    IIsqInit(&sqlca);
    IIsqExStmt(stmt_id,(int)0);
    IIsqDaIn((int)0,sqlda);
    IIsyncup("RdbIngresInsert.scc",(int)37);
  }
# line 38 "RdbIngresInsert.scc"	/* host code */
    if( sqlca.sqlcode )
      return Error(SQL_ERROR);
    return NO_ERROR;
}


RdbError::ErrorCode RdbIngresInsert::Describe()
{
  char *stmt = statement;
  char *stmt_id = id;

    ErrorCode rc = PrepareDA();
    if( rc )
      return rc;

    LOG("Describing "<<stmt<<'\n');
# line 56 "RdbIngresInsert.scc"	/* prepare */
  {
    IIsqInit(&sqlca);
    IIsqPrepare((int)0,stmt_id,(char *)0,(int)0,stmt);
  }
# line 57 "RdbIngresInsert.scc"	/* host code */
    if( sqlca.sqlcode )
      return Error(SQL_ERROR);
    ready = TRUE;
    return NO_ERROR;
}


RdbError::ErrorCode RdbIngresInsert::PrepareDA()
{
  char *stmt;
  char *stmt_id = id;

    int arity = rel.Arity();
    //tupleDA.Unprepare();
    tupleDA.Resize( arity );
    IISQLDA* sqlda = tupleDA;

    String s("select ");
    s += rel.ColName(0);
    for( int i = 1 ; i < arity ; i++ ) {
	s += String(",") + rel.ColName(i);
    }
    s += String(" from ") + rel.RelName();
    stmt = s;
    LOG("Describing "<<stmt<<'\n');
# line 84 "RdbIngresInsert.scc"	/* prepare */
  {
    IIsqInit(&sqlca);
    IIsqPrepare((int)0,stmt_id,sqlda,(int)0,stmt);
  }
# line 85 "RdbIngresInsert.scc"	/* host code */
    if( sqlca.sqlcode )
      return Error(SQL_ERROR);
    tupleDA.Prepare();
    assert(rel.Arity() == tupleDA.Arity());
    return NO_ERROR;
}


RdbError::ErrorCode RdbIngresInsert::Bind(const RdbItemList& bindings)
{
    int n = bindings.Size();
    if( n != tupleDA.Arity() )
      return Error(BAD_ARITY);
    for( int i = 0; i < n ; i++ ) {
	// should probably check for compatiblilty
	tupleDA.SetItem( i, bindings[i] );
	LOG("binding it to: "<<bindings[i]<<'\n');
    }
    return NO_ERROR;
}

