/* Print a char, converting chars to escape sequences. */
void fputs_metachr(char c, int in_str, FILE *fp)
{
    switch (c) {
      case '\'':
        if (in_str) 
          fputs("'",fp);
        else
          fputs("\\'",fp);
        break;
      case '"':
        if (in_str) 
          fputs("\\\"",fp);
        else
          fputs("\"",fp);
        break;
      case '\0':
        fputs("\\0",fp);
        break;
      case '\\':
        fputs("\\\\",fp);
        break;
      case '\n':
        fputs("\\n",fp);
        break;
      case '\t':
        fputs("\\t",fp);
        break;
      case '\r':
        fputs("\\r",fp);
        break;
      case '\f':
        fputs("\\f",fp);
        break;
      case '\b':
        fputs("\\b",fp);
        break;
      case '\v':
        fputs("\\v",fp);
        break;
      case '\a':
        fputs("\\a",fp);
        break;
      default:
        fputc(c,fp);
    }
}

/*  ###############################################################  */
/* Print a string, converting chars to escape sequences. */
void fputs_metastr(char *str, FILE *fp)
{
  while (*str) {
    fputs_metachr(*str,1,fp);
    str++;
  }
}

