// *************************************************************************
//    StackMark.h
// *************************************************************************

#ifndef _StackMark_H_
#define _StackMark_H_

#include "Trail.h"
#include "Debug.h"

// *************************************************************************
//    Currently trail is a global variable.  It should probably be made a 
//    parameter to StackMark, but currently isn't since it is less efficient. 

class Cor_StackMark {

    int trail_size;        // Size of trail when mark is made.

  public:
    // The following form should be used eventually.
    // StackMark(Trail &trail=NULL) { trail_size = CurTrail->TrailSize; }
    
    inline trail_index()    { return trail_size; }
    inline Cor_StackMark()        { trail_size = Cor_CurTrail->TrailSize; }
    inline void get_mark()    { trail_size = Cor_CurTrail->TrailSize; }
    inline void pop_to() {
        // Pop the Trail upto stackmark; 
        Cor_CurTrail->PopTrail(trail_size);
    }
};

// *************************************************************************

#endif _StackMark_H_
