// *************************************************************************
//    Database.h
// *************************************************************************

#ifndef _Database_H_
#define _Database_H_

#include "CArg.h"
#include "DatabaseStruct.h"
#include "Globals.h"
#include "Debug.h"

// *************************************************************************

#define COR_DB_RELS "exodus_ws"
#define COR_BUILTINS "builtin_ws"

// *************************************************************************

Cor_DatabaseStruct *Cor_lookupDB(Cor_CArg& name);
Cor_DatabaseStruct *Cor_createDB(Cor_CArg& name);
void Cor_clearDatabases();
int Cor_addDBStruct(Cor_DatabaseStruct *db);
int Cor_destroyDB(Cor_CArg& name);
int Cor_currentDB(Cor_CArg& name);
int Cor_renameDB(Cor_CArg& dbname, Cor_CArg& newName);
int Cor_saveDB(Cor_CArg& dbname, ostream *outf);
int Cor_copyToDB(Cor_CArg *srcrel, Cor_CArg& dbname, Cor_CArg *dstrel);
int Cor_addToDB(Cor_CArg *srcrel, Cor_CArg& dbname, Cor_CArg *dstrel);
int Cor_removeRelFromDB(Cor_CArg *rel, Cor_CArg& dbname);
int Cor_clearRelInDB(Cor_CArg *rel, Cor_CArg& dbname);
int Cor_openRelInCurDB(Cor_CArg *rel, Cor_CArg& dbname);
int Cor_listEveryDB();
int Cor_listRelsInDB(Cor_CArg& dbname, ostream *outfile = cerr_strm);

int Cor_renameRelation(Cor_CArg& relname, Cor_CArg& newName);

// *************************************************************************

#endif _Database_H_
