// *************************************************************************
//    DatabaseStruct.C
// *************************************************************************

#include "DatabaseStruct.h"
#include "Database.h"
#include "SymTable.h"
#include "Relation.h"
#include "Debug.h"

extern Cor_SymTable *Cor_DatabaseTable;

// *************************************************************************
Cor_DatabaseStruct::~Cor_DatabaseStruct()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    if (RelationTable) {
        if (! name.equals(COR_DB_RELS)) {
    
            Cor_SymCursor *cursor  = RelationTable->OpenScan();

            if (cursor) {
                do {
    
                    Cor_Relation *reln = (Cor_Relation *)
                            cursor->data();
    
                    if (reln && (! --(reln->ref_count))) {
                        // PRAVEEN:CHECK maybe this can be empty_relation(1) ???
                        reln->empty_relation(1);
                        delete reln;
                    }
    
                } while(cursor->ScanNext());
            }

            delete cursor;
        }
        delete RelationTable;
    }

   if (ModuleTable)
     delete ModuleTable;
}

// *************************************************************************

