//******************************************
// ExtJoin.C
//
// Ravi Murthy
//*****************************************

#ifdef    WITH_PERSISTENCE
#include "Plan.h"
#include "ExtJoin.h"

//**********************************************************

Cor_ExtJoin::Cor_ExtJoin(Cor_TupleIterator* left, Cor_TupleIterator *right)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    left_rel = left;
    right_rel = right;

    leaf = 1;
}

Cor_ExtJoin::Cor_ExtJoin(Cor_ExtJoin* left, Cor_TupleIterator *right)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    ext_left_rel = left;
    right_rel = right;

    leaf = 0;
}

Cor_ExtJoin::~Cor_ExtJoin()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    if (leaf == 1)
        delete left_rel;
    else
        delete ext_left_rel;

    delete right_rel;
}

// *************************************************************************
#endif // WITH_PERSISTENCE
