//********************************************
// ExtJoin.h
//
// Ravi Murthy
//*********************************************

#ifdef   WITH_PERSISTENCE
#ifndef _ExtJoin_H_
#define _ExtJoin_H_

#include "Relation.h"

class Cor_ExtJoin; 
//******************************************************

// This class is the base class of all external join methods. 
// The plan tree that is produced by the optimizer is a tree where
// each node is essentially of type ExtJoin.

class Cor_ExtJoin {
  public:
    Cor_ExtJoin(Cor_TupleIterator* left, Cor_TupleIterator *right);
    Cor_ExtJoin(Cor_ExtJoin* left, Cor_TupleIterator *right);
    virtual ~Cor_ExtJoin();

    virtual Cor_Tuple *get_next_tuple(Cor_TupleIterator& it) = 0;

    int leaf;

    union {
      Cor_TupleIterator *left_rel;
      Cor_ExtJoin *ext_left_rel;
    };

    Cor_TupleIterator *right_rel;
};

// *************************************************************************
#endif
#endif // WITH_PERSISTENCE
