
#include <stdlib.h>
#include <ostream.h>

#include "New.h"

#ifdef    COUNT_MEM_USE

    // This should be the largest type requiring alignment,
    // or a multiple of it, and must be large enough to hold size_t 
#define    XTRA_SPCE        (sizeof(double))

unsigned long Coral_memory_alloc = 0;
unsigned long Coral_memory_freed = 0;
unsigned long Coral_memory_inuse = 0;

unsigned long Coral_sizes_alloc[2000];
unsigned long Coral_sizes_freed[2000];
unsigned long Coral_sizes_inuse[2000];

  // Specific sizes of interest
unsigned long Coral_spec_sizes_alloc[8];
unsigned long Coral_spec_sizes_freed[8];
unsigned long Coral_spec_sizes_inuse[8];

    // Override new so we can count space
void * operator new(size_t size)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    if (size) {
        Coral_memory_inuse += size;
        Coral_memory_alloc += size;
    
        int sz_div = size / 8;

        if (sz_div < 2000) {    
            Coral_sizes_inuse[sz_div] += size;
            Coral_sizes_alloc[sz_div] += size;
        }

        void  *ret = malloc(size + XTRA_SPCE);
        size_t *sv_sze = (size_t*) ret;
        *sv_sze = size;
        return( ret + XTRA_SPCE );
    } else
        return(NULL);
}

    // Override new so we can count space
void   operator delete(void *trsh)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    if (trsh) {
        size_t *size = (size_t*) (trsh - XTRA_SPCE);

        if (*size > Coral_memory_inuse) {
            cout << "WARNING: Memory Size: " << Coral_memory_inuse << endl;
            cout << "Size is " << *size << endl;
        } else 
            Coral_memory_inuse -= *size;

        Coral_memory_freed += *size;
        int sz_div =  (*size) / 8;

        if (sz_div < 2000) {    
            Coral_sizes_inuse[sz_div] -= *size;
            Coral_sizes_freed[sz_div] += *size;
        }

        free(size);
    }
}

#endif

