// *************************************************************************
//    QueryStack.C
// *************************************************************************

#include "QueryStack.h"
#include "ArgList.h"

// *************************************************************************
        // The stack can grow, but start at a reasonable size
#define    DEFAULT_SIZE    8

// *************************************************************************
// push() returns the position
int  Cor_QueryStack::push(Cor_QueryInfo *x)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    if (length >= data_size) {

        if (data_size == 0) {
            data_size = DEFAULT_SIZE;
            data = new Cor_QueryInfo* [data_size];
        } else {

            int len = data_size;
            data_size += data_size;
            Cor_QueryInfo **tmp_data = data;
            data = new Cor_QueryInfo* [data_size];
            memcpy(data, tmp_data, len * sizeof(Cor_QueryInfo*));
            delete [] tmp_data;
        }
    }

    data[length++] = x;

    return(length-1);
}

// *************************************************************************
// Stream printing
ostream& operator<< (ostream& out, const Cor_QueryStack& qlist)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    if (qlist.length)
        out << qlist.data[0]->qid << ":" << *(qlist.data[0]->query);

    for (int j=1; j < qlist.length; j++)
        out << ", " << qlist.data[0]->qid << ":" << *(qlist.data[j]->query);

    return(out);
}

#undef    DEFAULT_SIZE
// *************************************************************************
