// *************************************************************************
//    ModuleEnv.C
// *************************************************************************

#include "ModuleEnv.h"

#include "QFMaterializedModuleData.h"
#include "Globals.h"
#include "Debug.h"

// *************************************************************************
Cor_ModuleEnv::Cor_ModuleEnv(Cor_QFMaterializedModuleData *parent)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    parent_md = parent;
    numSccs = parent->numSccs;
    scc_envs = new Cor_SccEnv *[numSccs];

    for (int i=0; i< numSccs; i++)
        scc_envs[i] = new Cor_SccEnv(parent->sccArray[i]);
}

// *************************************************************************
Cor_ModuleEnv::~Cor_ModuleEnv()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    for (int i=0; i < numSccs; i++)
        delete scc_envs[i];
    delete [] scc_envs;
}

// *************************************************************************
// Clear out the tuple iterators
void Cor_ModuleEnv::clear_tupits()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    for (int i=0; i < numSccs; i++)
        if (scc_envs[i])
            (scc_envs[i])->clear_tupits();
}

// *************************************************************************
