// *************************************************************************
//    Transaction.C
// *************************************************************************

#ifdef WITH_PERSISTENCE


#include "Globals.h"
#include "CoralError.h"
#include "SMUtil.h"
#include "sm_client.h"
#include "Config.h"
#include "Schema.h"
#include "IndexStruct.h"
#include "BPlusTreeIndex.h"
#include "FileDescStruct.h"
#include "BufferGroup.h"
#include "Transaction.h"
#include "Catalog.h"
#include "StorageManager.h"
#include "Debug.h"

// *************************************************************************
int Cor_Transaction::commit() 
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    if (TID_IS_INVALID(tid)) return 0;

    int e = sm_CommitTransaction(tid);
    ErrorCheck(e, "sm_CommitTransaction");

    INVALIDATE_TID(tid);

    return 1;
}

// *************************************************************************

#endif WITH_PERSISTENCE
